<template>
  <div class="comment-form-section">
    <UserInitials
      class="fr-mr-3v"
      :user="currentUser"
    />
    <form
      class="new-comment-form"
      @submit.prevent="onAddComment"
    >
      <AtomTextarea
        label="Nouveau commentaire"
        name="content"
        required
      >
        <template #hint>
          {{ SENSITIVE_DATA_HINT }}
        </template>
      </AtomTextarea>
      <ul
        class="fr-btns-group fr-btns-group--sm fr-btns-group--inline fr-btns-group--right"
      >
        <li>
          <button
            type="submit"
            class="fr-btn"
            :disabled="isSubmitting"
            :submitting="isSubmitting"
          >
            Ajouter
          </button>
        </li>
      </ul>
    </form>
  </div>
</template>

<script setup>
  import { SENSITIVE_DATA_HINT } from '~/utils/constants'
  import { useAuthStore } from '~/store/auth'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { dataObjectFromForm, formFromEvent } from '~~/utils/formData'

  const authStore = useAuthStore()
  const { $createItem, $snackbar } = useNuxtApp()

  const props = defineProps({
    history: { type: Object, required: true }
  })

  const emit = defineEmits(['commentAdded'])

  const isSubmitting = ref(false)

  const currentUser = computed(() => authStore.user)

  async function onAddComment(event) {
    const form = formFromEvent(event)
    isSubmitting.value = true
    const comment = {
      ...dataObjectFromForm(form)
    }

    if (props.history.isInterview) comment.interview = props.history.id
    else comment.help_request = props.history.id

    try {
      const res = await $createItem('comments', comment, {
        fields: ['*', 'user_created.first_name', 'user_created.last_name']
      })

      if (res.ok) {
        $snackbar.success(`Nouveau commentaire ajouté.`, () =>
          form.querySelector('textarea')?.focus()
        )
        form.reset()
        emit('commentAdded', res.data.data)
      } else throw new Error(errorResponseMessage(res))
    } catch {
      $snackbar.error("L'ajout du commentaire a échoué.", () =>
        form.querySelector('textarea')?.focus()
      )
    } finally {
      isSubmitting.value = false
    }
  }
</script>

<style>
  .comment-form-section {
    display: flex;
  }

  .new-comment-form {
    width: 100%;
    margin-right: 4px; /* Allow to display right ouline of the comment textarea */
  }
</style>
